/*
 * Copyright (c) 2012, Masanori Miyamoto.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 * 1.Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * 2.Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE FREEBSD PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 */ 
#ifndef __CZARBASIC_ERROR_H__
#define __CZARBASIC_ERROR_H__

enum error_code {
	ERR_NOERROR,
	ERR_STACK_OVERFLOW,
	ERR_STACK_UNDERFLOW,
	ERR_OUT_OF_RANGE,
	ERR_UNDEFINED_LINE_NUMBER,
	ERR_BUFFER_OVERFLOW,
	ERR_PROGMEM_OVERFLOW,
	ERR_STRINGMEM_OVERFLOW,
	ERR_LINENUMMEM_OVERFLOW,
	ERR_LINENUM,
	ERR_SYNTAX,
	ERR_OVERFLOW,
	ERR_OUTOFMEMORY,
	ERR_DIVISIONBYZERO,
	ERR_ALREADY_DEFINED_LINE_NUM,
	ERR_UNDEFINEDLABEL,
	ERR_RETURNWITHOUTGOSUB,
	ERR_UNDEFINEDINSTRUCTION,
	ERR_VMINTERNAL,
};

typedef enum error_code ERROR_CODE;

/* エラー終了 */
void ErrorMessage(ERROR_CODE err_code, int line_num);

#endif
